
unit linphonecore;
interface

{$LINKLIB c}
{$LINKLIB linphone}

uses BaseUnix;

{
  Automatically converted by H2Pas 1.0.0 from linphonecore.h
  The following command line parameters were used:
    -D
    -l
    linphone
    -o
    linphonecore.pp
    -p
    -T
    linphonecore.h
    
    Using linphone version 1.6.0 with yeaphone patch applied
    http://www.linphone.org
    http://www.devbase.at/voip/yeaphone.php
    
    Hand edited by Luca Olivetti <luca@ventoso.org>, just to compile a
    basic console application:
    
      - put all "type" sections together (for forward type resolution)
      - deleted duplicated definitions
      - TBool_t, TTime_t, Tms_mutex_t
      - changed momentarily unneded structures to generic pointer
      - commented out failing functions converted from macros
      - copied MSList definition from mscommon.h
      
}

    const
      External_library='linphone'; {Setup as you need}

    { Pointers to basic pascal types, inserted by h2pas conversion program.}
    Type
      PLongint  = ^Longint;
      PSmallInt = ^SmallInt;
      PByte     = ^Byte;
      PWord     = ^Word;
      PDWord    = ^DWord;
      PDouble   = ^Double;
      PPchar    = ^PChar;

    Type
{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}
    PAudioStream  = pointer; //^AudioStream;
    //Pautoreplier_config  = pointer; //^autoreplier_config;
    //Pautoreplier_config_t  = pointer; //^autoreplier_config_t;
    //Pcodecs_config  = pointer; //^codecs_config;
    //Pcodecs_config_t  = pointer; //^codecs_config_t;
    Pchar  = ^char;
    PFILE  = pointer; //^FILE;
    //Pgstate  = ^gstate;
    //Pgstate_group  = ^gstate_group;
    //Pgstate_group_t  = ^gstate_group_t;
    //Pgstate_t  = ^gstate_t;
    //PLCCallbackObj  = ^LCCallbackObj;
    //PLCState  = ^LCState;
    //PLinphoneAuthInfo  = ^LinphoneAuthInfo;
    //PLinphoneCall  = ^LinphoneCall;
    //PLinphoneCallDir  = ^LinphoneCallDir;
    PLinphoneCallLog  = ^TLinphoneCallLog;
    //PLinphoneCallStatus  = ^LinphoneCallStatus;
    //PLinphoneCore  = ^LinphoneCore;
    //PLinphoneCoreVTable  = ^LinphoneCoreVTable;
    //PLinphoneChatRoom  = ^LinphoneChatRoom;
    //PLinphoneFirewallPolicy  = ^LinphoneFirewallPolicy;
    //PLinphoneFriend  = ^LinphoneFriend;
    //PLinphoneGeneralState  = ^LinphoneGeneralState;
    //PLinphoneOnlineStatus  = ^LinphoneOnlineStatus;
    PLinphoneProxyConfig  = ^TLinphoneProxyConfig;
    PPLinphoneProxyConfig = ^PLinphoneProxyConfig;
    //PLinphoneSubscribePolicy  = ^LinphoneSubscribePolicy;
    //PLinphoneVTable  = ^LinphoneVTable;
    //PLpConfig  = ^LpConfig;
    PMSList  = ^MSList;
    //PMSSndCard  = pointer; //^MSSndCard;
    //Pnet_config  = pointer; //^net_config;
    //Pnet_config_t  = pointer; //^net_config_t;
    Posip_from_t  = pointer; //^osip_from_t; FIXME
    Posip_to_t  = pointer; //^osip_to_t;     FIXME
    PPosip_to_t = ^Posip_to_t;
    PPayloadType  = pointer; //^PayloadType; FIXME??
    //PRingBackType  = pointer; //^RingBackType;
    PRingStream  = pointer; //^RingStream;
    //Prtp_config  = pointer; //^rtp_config;
    //Prtp_config_t  = pointer; //^rtp_config_t;
    PRtpProfile  = pointer; //^RtpProfile;
    //Psdp_context  = pointer; //^sdp_context;
    //Psip_config  = pointer; //^sip_config;
    //Psip_config_t  = pointer; //^sip_config_t;
    //Psound_config  = pointer; //^sound_config;
    //Psound_config_t  = pointer; //^sound_config_t;
    //PStreamParams  = pointer; //^StreamParams;
    //Pui_config  = pointer; //^ui_config;
    //Pui_config_t  = pointer; //^ui_config_t;
    //Pvideo_config  = pointer; //^video_config;
    //Pvideo_config_t  = pointer; //^video_config_t;
    PVideoStream  = pointer; //^VideoStream;
    
    Tbool_t = boolean;
    TTime_t = time_t;
    Tms_mutex_t = pthread_mutex_t;


  {
  linphone
  Copyright (C) 2000  Simon MORLAT (simon.morlat@linphone.org)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
   }
//{$ifndef LINPHONECORE_H}
//{$define LINPHONECORE_H}
//{$include <osipparser2/osip_message.h>}
//{$include <ortp/ortp.h>}
//{$include <ortp/payloadtype.h>}
//{$include <mediastreamer2/mscommon.h>}
{ C++ extern C conditionnal removed }

     //Copied from mscommon.h
     MSList = record
         next:PMSList;
         prev:PMSList;
         data:pointer;
       end;

     PMSSndCard = ^TMSSndCard;
     TMSSndCard = record
         {undefined structure}
       end;

     PLinphoneCore = ^TLinphoneCore;
     //TLinphoneCore = record
     //    {undefined structure}
     //  end;

     PLpConfig = ^TLpConfig;
     TLpConfig = record
        F:PFile;
        filename:PChar;
        sections:PMSList;
       end;

  {timeout after an un-answered incoming call is rejected }

     Psip_config = ^Tsip_config;
     Tsip_config = record
          contact : Pchar;
          guessed_contact : Pchar;
          sip_port : longint;
          proxies : PMSList;
          deleted_proxies : PMSList;
          inc_timeout : longint;
          use_info : Tbool_t;
          guess_hostname : Tbool_t;
          loopback_only : Tbool_t;
          ipv6_enabled : Tbool_t;
       end;
     Tsip_config_t = Tsip_config;
     Psip_config_t = ^Tsip_config_t;
  {jitter compensation }
  {jitter compensation }

     Prtp_config = ^Trtp_config;
     Trtp_config = record
          audio_rtp_port : longint;
          video_rtp_port : longint;
          audio_jitt_comp : longint;
          video_jitt_comp : longint;
       end;
     Trtp_config_t = Trtp_config;
     Prtp_config_t = ^Trtp_config_t;

     Pnet_config = ^Tnet_config;
     Tnet_config = record
          nat_address : Pchar;
          stun_server : Pchar;
          download_bw : longint;
          upload_bw : longint;
          firewall_policy : longint;
          nat_sdp_only : Tbool_t;
       end;
     Tnet_config_t = Tnet_config;
     Pnet_config_t = ^Tnet_config_t;
  { the playback sndcard currently used  }
  { the playback sndcard currently used  }
  { the capture sndcard currently used  }
(* Const before type ignored *)
  { latency in samples of the current used sound device  }

     Psound_config = ^Tsound_config;
     Tsound_config = record
          ring_sndcard : PMSSndCard;
          play_sndcard : PMSSndCard;
          capt_sndcard : PMSSndCard;
          cards : ^Pchar;
          latency : longint;
          rec_lev : char;
          play_lev : char;
          ring_lev : char;
          source : char;
          pad : char;
          local_ring : Pchar;
          remote_ring : Pchar;
          ec : Tbool_t;
       end;
     Tsound_config_t = Tsound_config;
     Psound_config_t = ^Tsound_config_t;
  { list of audio codecs in order of preference }
  { for later use }

     Pcodecs_config = ^Tcodecs_config;
     Tcodecs_config = record
          audio_codecs : PMSList;
          video_codecs : PMSList;
       end;
     Tcodecs_config_t = Tcodecs_config;
     Pcodecs_config_t = ^Tcodecs_config_t;

     Pvideo_config = ^Tvideo_config;
     Tvideo_config = record
          device : Pchar;
          enabled : Tbool_t;
          show_local : Tbool_t;
       end;
     Tvideo_config_t = Tvideo_config;
     Pvideo_config_t = ^Tvideo_config_t;
  { the timer id for registration  }

     Pui_config = ^Tui_config;
     Tui_config = record
          is_daemon : longint;
          is_applet : longint;
          timer_id : dword;
       end;
     Tui_config_t = Tui_config;
     Pui_config_t = ^Tui_config_t;
  { accept the call after x seconds }
  { maximum number of user that can call simultaneously  }
  { the max time of incoming voice recorded  }
  { maximum number of recorded messages  }
(* Const before type ignored *)
  { the path of the file to be played  }

     Pautoreplier_config = ^Tautoreplier_config;
     Tautoreplier_config = record
          enabled : longint;
          after_seconds : longint;
          max_users : longint;
          max_rec_time : longint;
          max_rec_msg : longint;
          message : Pchar;
       end;
     Tautoreplier_config_t = Tautoreplier_config;
     Pautoreplier_config_t = ^Tautoreplier_config_t;
     //PLinphoneCore = ^TLinphoneCore;
     //TLinphoneCore = record
     //    {undefined structure}
     //  end;

     Psdp_context = ^Tsdp_context;
     Tsdp_context = record
         {undefined structure}
       end;


     PStreamParams = ^TStreamParams;
     TStreamParams = record
          initialized : longint;
          line : longint;
          localport : longint;
          remoteport : longint;
          remoteaddr : Pchar;
          pt : longint;
       end;

     PLCState = ^TLCState;
     TLCState = (LCStateInit,LCStateRinging,LCStateAVRunning
       );

     PLinphoneCallDir = ^TLinphoneCallDir;
     TLinphoneCallDir = (LinphoneCallOutgoing,LinphoneCallIncoming
       );
  {points to the local_profile or to the remote "guessed" profile }
  {call id  }
  {dialog id  }

     PLinphoneCall = ^TLinphoneCall;
     TLinphoneCall = record
          core : PLinphoneCore;
          audio_params : TStreamParams;
          video_params : TStreamParams;
          dir : TLinphoneCallDir;
          profile : PRtpProfile;
          log : PLinphoneCallLog;
          cid : longint;
          did : longint;
          sdpctx : Psdp_context;
          start_time : Ttime_t;
          state : TLCState;
          auth_pending : Tbool_t;
       end;
       
       PLinphoneCallStatus = ^TLinphoneCallStatus;
       TLinphoneCallStatus = (LinphoneCallSuccess,LinphoneCallAborted,
         LinphoneCallMissed);

       //PLinphoneCallLog = ^TLinphoneCallLog;
       TLinphoneCallLog = record
            lc : PLinphoneCore;
            dir : TLinphoneCallDir;
            status : TLinphoneCallStatus;
            from : Pchar;
            tooo : Pchar;
            start_date : array[0..127] of char;
            duration : longint;
         end;
         
       PLinphoneSubscribePolicy = ^TLinphoneSubscribePolicy;
       TLinphoneSubscribePolicy = (LinphoneSPWait,LinphoneSPDeny,LinphoneSPAccept
         );
    { not stored, use for immediate outgoing subscribe after receiving incoming subscribe }

       PLinphoneFriend = ^TLinphoneFriend;
       TLinphoneFriend = record
            url : Posip_from_t;
            contact : Pchar;
            sid : longint;
            nid : longint;
            last_outsubsc : longint;
            pol : TLinphoneSubscribePolicy;
            proxy : PLinphoneProxyConfig;
            lc : PLinphoneCore;
            subscribe : Tbool_t;
            inc_subscribe_pending : Tbool_t;
         end;

       //PLinphoneProxyConfig = ^TLinphoneProxyConfig;
       TLinphoneProxyConfig = record
            lc : PLinphoneCore;
            reg_proxy : Pchar;
            reg_identity : Pchar;
            reg_route : Pchar;
            realm : Pchar;
            expires : longint;
            reg_time : longint;
            rid : longint;
            frozen : Tbool_t;
            reg_sendregister : Tbool_t;
            auth_pending : Tbool_t;
            registered : Tbool_t;
            publish : Tbool_t;
         end;
         
       PLinphoneAuthInfo = ^TLinphoneAuthInfo;
       TLinphoneAuthInfo = record
            username : Pchar;
            realm : Pchar;
            userid : Pchar;
            passwd : Pchar;
            ha1 : Pchar;
            works : Tbool_t;
         end;

       PLinphoneChatRoom = ^TLinphoneChatRoom;
       TLinphoneChatRoom = record
            lc : PLinphoneCore;
            peer : Pchar;
            peer_url : Posip_from_t;
            user_data : pointer;
         end;

       Pgstate_group = ^Tgstate_group;
       Tgstate_group = (GSTATE_GROUP_POWER,GSTATE_GROUP_REG,
         GSTATE_GROUP_CALL);
       Tgstate_group_t = Tgstate_group;
       Pgstate_group_t = ^Tgstate_group_t;
    { states for GSTATE_GROUP_POWER  }
    { initial state  }
    { states for GSTATE_GROUP_REG  }
    { initial state  }
    { states for GSTATE_GROUP_CALL  }
    { initial state  }

       Pgstate = ^Tgstate;
       Tgstate = (GSTATE_POWER_OFF := 0,GSTATE_POWER_STARTUP,
         GSTATE_POWER_ON,GSTATE_POWER_SHUTDOWN,
         GSTATE_REG_NONE := 10,GSTATE_REG_OK,
         GSTATE_REG_FAILED,GSTATE_CALL_IDLE := 20,
         GSTATE_CALL_OUT_INVITE,GSTATE_CALL_OUT_CONNECTED,
         GSTATE_CALL_IN_INVITE,GSTATE_CALL_IN_CONNECTED,
         GSTATE_CALL_END,GSTATE_CALL_ERROR
         );
       Tgstate_t = Tgstate;
       Pgstate_t = ^Tgstate_t;
(* Const before type ignored *)
       PLinphoneGeneralState = ^TLinphoneGeneralState;
       TLinphoneGeneralState = record
            old_state : Tgstate_t;
            new_state : Tgstate_t;
            group : Tgstate_group_t;
            message : Pchar;
         end;
         
       TShowInterfaceCb = procedure (lc:PLinphoneCore);cdecl;
(* Const before type ignored *)

       TInviteReceivedCb = procedure (lc:PLinphoneCore; from:Pchar);cdecl;
(* Const before type ignored *)

       TByeReceivedCb = procedure (lc:PLinphoneCore; from:Pchar);cdecl;
(* Const before type ignored *)

       TDisplayStatusCb = procedure (lc:PLinphoneCore; message:Pchar);cdecl;
(* Const before type ignored *)

       TDisplayMessageCb = procedure (lc:PLinphoneCore; message:Pchar);cdecl;
(* Const before type ignored *)
(* Const before type ignored *)

       TDisplayUrlCb = procedure (lc:PLinphoneCore; message:Pchar; url:Pchar);cdecl;
(* Const before type ignored *)

       TDisplayQuestionCb = procedure (lc:PLinphoneCore; message:Pchar);cdecl;

       TLinphoneCoreCbFunc = procedure (lc:PLinphoneCore; user_data:pointer);cdecl;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)

       TNotifyReceivedCb = procedure (lc:PLinphoneCore; fid:PLinphoneFriend; url:Pchar; status:Pchar; img:Pchar);cdecl;
(* Const before type ignored *)

       TNewUnknownSubscriberCb = procedure (lc:PLinphoneCore; lf:PLinphoneFriend; url:Pchar);cdecl;
(* Const before type ignored *)
(* Const before type ignored *)

       TAuthInfoRequested = procedure (lc:PLinphoneCore; realm:Pchar; username:Pchar);cdecl;

       TCallLogUpdated = procedure (lc:PLinphoneCore; newcl:PLinphoneCallLog);cdecl;
(* Const before type ignored *)
(* Const before type ignored *)

       TTextMessageReceived = procedure (lc:PLinphoneCore; room:PLinphoneChatRoom; from:Pchar; message:Pchar);cdecl;

       TGeneralStateChange = procedure (lc:PLinphoneCore; gstate:PLinphoneGeneralState);cdecl;

       PLinphoneVTable = ^TLinphoneVTable;
       TLinphoneVTable = record
            show : TShowInterfaceCb;
            inv_recv : TInviteReceivedCb;
            bye_recv : TByeReceivedCb;
            notify_recv : TNotifyReceivedCb;
            new_unknown_subscriber : TNewUnknownSubscriberCb;
            auth_info_requested : TAuthInfoRequested;
            display_status : TDisplayStatusCb;
            display_message : TDisplayMessageCb;
{$ifdef VINCENT_MAURY_RSVP}
    { the yes/no dialog box  }
            display_yes_no : TDisplayMessageCb;
{$endif}
            display_warning : TDisplayMessageCb;
            display_url : TDisplayUrlCb;
            display_question : TDisplayQuestionCb;
            call_log_updated : TCallLogUpdated;
            text_received : TTextMessageReceived;
            general_state : TGeneralStateChange;
         end;
       TLinphoneCoreVTable = TLinphoneVTable;
       PLinphoneCoreVTable = ^TLinphoneCoreVTable;

       PLCCallbackObj = ^TLCCallbackObj;
       TLCCallbackObj = record
            _func : TLinphoneCoreCbFunc;
            _user_data : pointer;
         end;

       PLinphoneOnlineStatus = ^TLinphoneOnlineStatus;
       TLinphoneOnlineStatus = (LINPHONE_STATUS_UNKNOWN,LINPHONE_STATUS_ONLINE,
         LINPHONE_STATUS_BUSY,LINPHONE_STATUS_BERIGHTBACK,
         LINPHONE_STATUS_AWAY,LINPHONE_STATUS_ONTHEPHONE,
         LINPHONE_STATUS_OUTTOLUNCH,LINPHONE_STATUS_NOT_DISTURB,
         LINPHONE_STATUS_MOVED,LINPHONE_STATUS_ALT_SERVICE,
         LINPHONE_STATUS_OFFLINE,LINPHONE_STATUS_END
         );

       PLinphoneFirewallPolicy = ^TLinphoneFirewallPolicy;
       TLinphoneFirewallPolicy = (LINPHONE_POLICY_NO_FIREWALL,LINPHONE_POLICY_USE_NAT_ADDRESS,
         LINPHONE_POLICY_USE_STUN);
    { the current call, in the future it will be a list of calls (conferencing) }
    {registration id }
    { used by the autoreplier  }
    { }
    { unknown subscribers  }

       //PLinphoneCore = ^TLinphoneCore;
       TLinphoneCore = record
            vtable : TLinphoneCoreVTable;
            config : PLpConfig;
            net_conf : Tnet_config_t;
            sip_conf : Tsip_config_t;
            rtp_conf : Trtp_config_t;
            sound_conf : Tsound_config_t;
            video_conf : Tvideo_config_t;
            codecs_conf : Tcodecs_config_t;
            ui_conf : Tui_config_t;
            autoreplier_conf : Tautoreplier_config_t;
            default_proxy : PLinphoneProxyConfig;
            friends : PMSList;
            auth_info : PMSList;
            ringstream : PRingStream;
            preview_finished_cb : TLCCallbackObj;
            preview_finished : Tbool_t;
            call : PLinphoneCall;
            rid : longint;
            queued_calls : PMSList;
            call_logs : PMSList;
            chatrooms : PMSList;
            max_call_logs : longint;
            missed_calls : longint;
            audiostream : PAudioStream;
            videostream : PVideoStream;
            previewstream : PVideoStream;
            local_profile : PRtpProfile;
            subscribers : PMSList;
            minutes_away : longint;
            presence_mode : TLinphoneOnlineStatus;
            alt_contact : Pchar;
            data : pointer;
            lock : Tms_mutex_t;
            play_file : Pchar;
            rec_file : Pchar;
            prevtime : Ttime_t;
            dw_audio_bw : longint;
            up_audio_bw : longint;
            dw_video_bw : longint;
            up_video_bw : longint;
            use_files : Tbool_t;
            apply_nat_settings : Tbool_t;
{$ifdef VINCENT_MAURY_RSVP}
    { QoS parameters }
            rsvp_enable : longint;
            rpc_enable : longint;
{$endif}
         end;

(* Const before type ignored *)
(* Const before type ignored *)
  function payload_type_enabled(pt:PPayloadType):Tbool_t;cdecl;external External_library name 'payload_type_enabled';

(* Const before type ignored *)
  function payload_type_check_usable(pt:PPayloadType; lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'payload_type_check_usable';

  procedure payload_type_set_enable(pt:PPayloadType; value:longint);cdecl;external External_library name 'payload_type_set_enable';

(* Const before type ignored *)
  function payload_type_get_description(pt:PPayloadType):Pchar;cdecl;external External_library name 'payload_type_get_description';

  function payload_type_get_bitrate(pt:PPayloadType):longint;cdecl;external External_library name 'payload_type_get_bitrate';

(* Const before type ignored *)
  function payload_type_get_mime(pt:PPayloadType):Pchar;cdecl;external External_library name 'payload_type_get_mime';

  function payload_type_get_rate(pt:PPayloadType):longint;cdecl;external External_library name 'payload_type_get_rate';

  function linphone_call_new_outgoing(lc:PLinphoneCore; from:Posip_from_t; tooo:Posip_to_t):PLinphoneCall;cdecl;external External_library name 'linphone_call_new_outgoing';

(* Const before type ignored *)
(* Const before type ignored *)
  function linphone_call_new_incoming(lc:PLinphoneCore; from:Pchar; tooo:Pchar; cid:longint; did:longint):PLinphoneCall;cdecl;external External_library name 'linphone_call_new_incoming';

(* error 
#define linphone_call_set_state(lcall,st)	(lcall)->state=(st)
in define line 171 *)
    procedure linphone_call_destroy(obj:PLinphoneCall);cdecl;external External_library name 'linphone_call_destroy';



    { private:  }

    function linphone_call_log_new(call:PLinphoneCall; local:Pchar; remote:Pchar):PLinphoneCallLog;cdecl;external External_library name 'linphone_call_log_new';

    procedure linphone_call_log_completed(calllog:PLinphoneCallLog; call:PLinphoneCall);cdecl;external External_library name 'linphone_call_log_completed';

    procedure linphone_call_log_destroy(cl:PLinphoneCallLog);cdecl;external External_library name 'linphone_call_log_destroy';

    {public:  }
    function linphone_call_log_to_str(cl:PLinphoneCallLog):Pchar;cdecl;external External_library name 'linphone_call_log_to_str';

    function linphone_friend_new:PLinphoneFriend;cdecl;external External_library name 'linphone_friend_new';

(* Const before type ignored *)
    function linphone_friend_new_with_addr(addr:Pchar):PLinphoneFriend;cdecl;external External_library name 'linphone_friend_new_with_addr';

(* Const before type ignored *)
    function linphone_friend_set_sip_addr(fr:PLinphoneFriend; name:Pchar):longint;cdecl;external External_library name 'linphone_friend_set_sip_addr';

    function linphone_friend_send_subscribe(fr:PLinphoneFriend; val:Tbool_t):longint;cdecl;external External_library name 'linphone_friend_send_subscribe';

    function linphone_friend_set_inc_subscribe_policy(fr:PLinphoneFriend; pol:TLinphoneSubscribePolicy):longint;cdecl;external External_library name 'linphone_friend_set_inc_subscribe_policy';

    function linphone_friend_set_proxy(fr:PLinphoneFriend; cfg:PLinphoneProxyConfig):longint;cdecl;external External_library name 'linphone_friend_set_proxy';

    procedure linphone_friend_edit(fr:PLinphoneFriend);cdecl;external External_library name 'linphone_friend_edit';

    procedure linphone_friend_done(fr:PLinphoneFriend);cdecl;external External_library name 'linphone_friend_done';

    procedure linphone_friend_destroy(lf:PLinphoneFriend);cdecl;external External_library name 'linphone_friend_destroy';

    { memory returned by those 3 functions must be freed  }
    function linphone_friend_get_name(lf:PLinphoneFriend):Pchar;cdecl;external External_library name 'linphone_friend_get_name';

    function linphone_friend_get_addr(lf:PLinphoneFriend):Pchar;cdecl;external External_library name 'linphone_friend_get_addr';

    function linphone_friend_get_url(lf:PLinphoneFriend):Pchar;cdecl;external External_library name 'linphone_friend_get_url';

    { name <sip address>  }
    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_friend_url(lf : longint) : longint;    

    procedure linphone_friend_write_to_config_file(config:PLpConfig; lf:PLinphoneFriend; index:longint);cdecl;external External_library name 'linphone_friend_write_to_config_file';

    function linphone_friend_new_from_config_file(lc:PLinphoneCore; index:longint):PLinphoneFriend;cdecl;external External_library name 'linphone_friend_new_from_config_file';


(* Const before type ignored *)

    function linphone_proxy_config_new(server_addr:Pchar):PLinphoneProxyConfig;cdecl;external External_library name 'linphone_proxy_config_new';

(* Const before type ignored *)
    function linphone_proxy_config_set_server_addr(obj:PLinphoneProxyConfig; server_addr:Pchar):longint;cdecl;external External_library name 'linphone_proxy_config_set_server_addr';

(* Const before type ignored *)
    procedure linphone_proxy_config_set_identity(obj:PLinphoneProxyConfig; identity:Pchar);cdecl;external External_library name 'linphone_proxy_config_set_identity';

(* Const before type ignored *)
    procedure linphone_proxy_config_set_route(obj:PLinphoneProxyConfig; route:Pchar);cdecl;external External_library name 'linphone_proxy_config_set_route';

(* Const before type ignored *)
    procedure linphone_proxy_config_expires(obj:PLinphoneProxyConfig; expires:longint);cdecl;external External_library name 'linphone_proxy_config_expires';

    procedure linphone_proxy_config_enableregister(obj:PLinphoneProxyConfig; val:Tbool_t);cdecl;external External_library name 'linphone_proxy_config_enableregister';

    procedure linphone_proxy_config_edit(obj:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_proxy_config_edit';

    procedure linphone_proxy_config_done(obj:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_proxy_config_done';

    procedure linphone_proxy_config_enable_publish(obj:PLinphoneProxyConfig; val:Tbool_t);cdecl;external External_library name 'linphone_proxy_config_enable_publish';

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_route(obj : longint) : longint;    

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_identity(obj : longint) : longint;    

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_publish_enabled(obj : longint) : longint;    

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_addr(obj : longint) : longint;    

    { destruction is called automatically when removing the proxy config  }
    procedure linphone_proxy_config_destroy(cfg:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_proxy_config_destroy';

    function linphone_proxy_config_new_from_config_file(config:PLpConfig; index:longint):PLinphoneProxyConfig;cdecl;external External_library name 'linphone_proxy_config_new_from_config_file';

    procedure linphone_proxy_config_write_to_config_file(config:PLpConfig; obj:PLinphoneProxyConfig; index:longint);cdecl;external External_library name 'linphone_proxy_config_write_to_config_file';


(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)

    function linphone_auth_info_new(username:Pchar; userid:Pchar; passwd:Pchar; ha1:Pchar; realm:Pchar):PLinphoneAuthInfo;cdecl;external External_library name 'linphone_auth_info_new';

(* Const before type ignored *)
    procedure linphone_auth_info_set_passwd(info:PLinphoneAuthInfo; passwd:Pchar);cdecl;external External_library name 'linphone_auth_info_set_passwd';

    { you don't need those function }
    procedure linphone_auth_info_destroy(info:PLinphoneAuthInfo);cdecl;external External_library name 'linphone_auth_info_destroy';

    function linphone_auth_info_new_from_config_file(config:PLpConfig; pos:longint):PLinphoneAuthInfo;cdecl;external External_library name 'linphone_auth_info_new_from_config_file';


(* Const before type ignored *)

    function linphone_core_create_chat_room(lc:PLinphoneCore; tooo:Pchar):PLinphoneChatRoom;cdecl;external External_library name 'linphone_core_create_chat_room';

(* Const before type ignored *)
    procedure linphone_chat_room_send_message(cr:PLinphoneChatRoom; msg:Pchar);cdecl;external External_library name 'linphone_chat_room_send_message';

    procedure linphone_chat_room_destroy(cr:PLinphoneChatRoom);cdecl;external External_library name 'linphone_chat_room_destroy';

    procedure linphone_chat_room_set_user_data(cr:PLinphoneChatRoom; ud:pointer);cdecl;external External_library name 'linphone_chat_room_set_user_data';

    function linphone_chat_room_get_user_data(cr:PLinphoneChatRoom):pointer;cdecl;external External_library name 'linphone_chat_room_get_user_data';

    { describes the different groups of states  }

    { retrieve the current state of the specified state group  }

    function gstate_get_state(group:Tgstate_group_t):Tgstate_t;cdecl;external External_library name 'gstate_get_state';

    { private: set the initial states  }
    procedure gstate_initialize;cdecl;external External_library name 'gstate_initialize';

    { private: set a new state  }
(* Const before type ignored *)
    procedure gstate_new_state(lc:PLinphoneCore; new_state:Tgstate_t; message:Pchar);cdecl;external External_library name 'gstate_new_state';

    const
       LINPHONE_IPADDR_SIZE = 64;       
    { THE main API  }

    procedure linphone_core_enable_logs(f:PFILE);cdecl;external External_library name 'linphone_core_enable_logs';

    procedure linphone_core_disable_logs;cdecl;external External_library name 'linphone_core_disable_logs';

(* Const before type ignored *)
    function linphone_core_get_version:Pchar;cdecl;external External_library name 'linphone_core_get_version';

(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_new(vtable:PLinphoneCoreVTable; config_path:Pchar; userdata:pointer):PLinphoneCore;cdecl;external External_library name 'linphone_core_new';

(* Const before type ignored *)
(* Const before type ignored *)
    procedure linphone_core_init(lc:PLinphoneCore; vtable:PLinphoneCoreVTable; config_path:Pchar; userdata:pointer);cdecl;external External_library name 'linphone_core_init';

    { function to be periodically called in a main loop  }
    procedure linphone_core_iterate(lc:PLinphoneCore);cdecl;external External_library name 'linphone_core_iterate';

(* Const before type ignored *)
    function linphone_core_invite(lc:PLinphoneCore; url:Pchar):longint;cdecl;external External_library name 'linphone_core_invite';

(* Const before type ignored *)
    function linphone_core_refer(lc:PLinphoneCore; url:Pchar):longint;cdecl;external External_library name 'linphone_core_refer';

    function linphone_core_inc_invite_pending(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_inc_invite_pending';

(* Const before type ignored *)
    function linphone_core_accept_call(lc:PLinphoneCore; url:Pchar):longint;cdecl;external External_library name 'linphone_core_accept_call';

(* Const before type ignored *)
    function linphone_core_terminate_call(lc:PLinphoneCore; url:Pchar):longint;cdecl;external External_library name 'linphone_core_terminate_call';

    procedure linphone_core_send_dtmf(lc:PLinphoneCore; dtmf:char);cdecl;external External_library name 'linphone_core_send_dtmf';

(* Const before type ignored *)
    function linphone_core_set_primary_contact(lc:PLinphoneCore; contact:Pchar):longint;cdecl;external External_library name 'linphone_core_set_primary_contact';

(* Const before type ignored *)
    function linphone_core_get_primary_contact(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_primary_contact';

    procedure linphone_core_set_guess_hostname(lc:PLinphoneCore; val:Tbool_t);cdecl;external External_library name 'linphone_core_set_guess_hostname';

    function linphone_core_get_guess_hostname(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_get_guess_hostname';

    function linphone_core_ipv6_enabled(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_ipv6_enabled';

    procedure linphone_core_enable_ipv6(lc:PLinphoneCore; val:Tbool_t);cdecl;external External_library name 'linphone_core_enable_ipv6';

    function linphone_core_get_primary_contact_parsed(lc:PLinphoneCore):Posip_from_t;cdecl;external External_library name 'linphone_core_get_primary_contact_parsed';

    {0= no bandwidth limit }
    procedure linphone_core_set_download_bandwidth(lc:PLinphoneCore; bw:longint);cdecl;external External_library name 'linphone_core_set_download_bandwidth';

    procedure linphone_core_set_upload_bandwidth(lc:PLinphoneCore; bw:longint);cdecl;external External_library name 'linphone_core_set_upload_bandwidth';

(* Const before type ignored *)
    function linphone_core_get_download_bandwidth(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_download_bandwidth';

(* Const before type ignored *)
    function linphone_core_get_upload_bandwidth(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_upload_bandwidth';

{$ifdef VINCENT_MAURY_RSVP}
    { QoS functions  }

    function linphone_core_set_rpc_mode(lc:PLinphoneCore; on:longint):longint;cdecl;external External_library name 'linphone_core_set_rpc_mode';

    { on = 1 (RPC_ENABLE = 1)  }
    function linphone_core_set_rsvp_mode(lc:PLinphoneCore; on:longint):longint;cdecl;external External_library name 'linphone_core_set_rsvp_mode';

    { on = 1 (RSVP_ENABLE = 1)  }
    function linphone_core_change_qos(lc:PLinphoneCore; answer:longint):longint;cdecl;external External_library name 'linphone_core_change_qos';

    { answer = 1 for yes, 0 for no  }
{$endif}
    { returns a MSList of PayloadType  }
(* Const before type ignored *)
(* Const before type ignored *)

    function linphone_core_get_audio_codecs(lc:PLinphoneCore):PMSList;cdecl;external External_library name 'linphone_core_get_audio_codecs';

    function linphone_core_set_audio_codecs(lc:PLinphoneCore; codecs:PMSList):longint;cdecl;external External_library name 'linphone_core_set_audio_codecs';

    { returns a MSList of PayloadType  }
(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_get_video_codecs(lc:PLinphoneCore):PMSList;cdecl;external External_library name 'linphone_core_get_video_codecs';

    function linphone_core_set_video_codecs(lc:PLinphoneCore; codecs:PMSList):longint;cdecl;external External_library name 'linphone_core_set_video_codecs';

(* Const before type ignored *)
    function linphone_core_check_payload_type_usability(lc:PLinphoneCore; pt:PPayloadType):Tbool_t;cdecl;external External_library name 'linphone_core_check_payload_type_usability';

    procedure linphone_core_add_proxy_config(lc:PLinphoneCore; config:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_core_add_proxy_config';

    procedure linphone_core_remove_proxy_config(lc:PLinphoneCore; config:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_core_remove_proxy_config';

(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_get_proxy_config_list(lc:PLinphoneCore):PMSList;cdecl;external External_library name 'linphone_core_get_proxy_config_list';

    procedure linphone_core_set_default_proxy(lc:PLinphoneCore; config:PLinphoneProxyConfig);cdecl;external External_library name 'linphone_core_set_default_proxy';

    procedure linphone_core_set_default_proxy_index(lc:PLinphoneCore; index:longint);cdecl;external External_library name 'linphone_core_set_default_proxy_index';

    function linphone_core_get_default_proxy(lc:PLinphoneCore; config:PPLinphoneProxyConfig):longint;cdecl;external External_library name 'linphone_core_get_default_proxy';

    procedure linphone_core_add_auth_info(lc:PLinphoneCore; info:PLinphoneAuthInfo);cdecl;external External_library name 'linphone_core_add_auth_info';

    procedure linphone_core_remove_auth_info(lc:PLinphoneCore; info:PLinphoneAuthInfo);cdecl;external External_library name 'linphone_core_remove_auth_info';

    procedure linphone_core_clear_all_auth_info(lc:PLinphoneCore);cdecl;external External_library name 'linphone_core_clear_all_auth_info';

    function linphone_core_get_audio_jittcomp(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_audio_jittcomp';

    procedure linphone_core_set_audio_jittcomp(lc:PLinphoneCore; value:longint);cdecl;external External_library name 'linphone_core_set_audio_jittcomp';

(* Const before type ignored *)
    function linphone_core_get_audio_port(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_audio_port';

(* Const before type ignored *)
    function linphone_core_get_video_port(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_video_port';

    procedure linphone_core_set_audio_port(lc:PLinphoneCore; port:longint);cdecl;external External_library name 'linphone_core_set_audio_port';

    procedure linphone_core_set_video_port(lc:PLinphoneCore; port:longint);cdecl;external External_library name 'linphone_core_set_video_port';

    procedure linphone_core_set_use_info_for_dtmf(lc:PLinphoneCore; use_info:Tbool_t);cdecl;external External_library name 'linphone_core_set_use_info_for_dtmf';

    function linphone_core_get_use_info_for_dtmf(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_get_use_info_for_dtmf';

    function linphone_core_get_sip_port(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_sip_port';

    procedure linphone_core_set_sip_port(lc:PLinphoneCore; port:longint);cdecl;external External_library name 'linphone_core_set_sip_port';

    procedure linphone_core_set_inc_timeout(lc:PLinphoneCore; seconds:longint);cdecl;external External_library name 'linphone_core_set_inc_timeout';

    function linphone_core_get_inc_timeout(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_inc_timeout';

(* Const before type ignored *)
    procedure linphone_core_set_stun_server(lc:PLinphoneCore; server:Pchar);cdecl;external External_library name 'linphone_core_set_stun_server';

(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_get_stun_server(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_stun_server';

(* Const before type ignored *)
    procedure linphone_core_set_nat_address(lc:PLinphoneCore; addr:Pchar);cdecl;external External_library name 'linphone_core_set_nat_address';

(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_get_nat_address(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_nat_address';

    procedure linphone_core_set_firewall_policy(lc:PLinphoneCore; pol:TLinphoneFirewallPolicy);cdecl;external External_library name 'linphone_core_set_firewall_policy';

(* Const before type ignored *)
    function linphone_core_get_firewall_policy(lc:PLinphoneCore):TLinphoneFirewallPolicy;cdecl;external External_library name 'linphone_core_get_firewall_policy';

    { sound functions  }
    { returns a null terminated static array of string describing the sound devices  }(* Const before type ignored *)
    function linphone_core_get_sound_devices(lc:PLinphoneCore):PPchar;cdecl;external External_library name 'linphone_core_get_sound_devices';

    function linphone_core_get_ring_level(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_ring_level';

    function linphone_core_get_play_level(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_play_level';

    function linphone_core_get_rec_level(lc:PLinphoneCore):longint;cdecl;external External_library name 'linphone_core_get_rec_level';

    procedure linphone_core_set_ring_level(lc:PLinphoneCore; level:longint);cdecl;external External_library name 'linphone_core_set_ring_level';

    procedure linphone_core_set_play_level(lc:PLinphoneCore; level:longint);cdecl;external External_library name 'linphone_core_set_play_level';

    procedure linphone_core_set_rec_level(lc:PLinphoneCore; level:longint);cdecl;external External_library name 'linphone_core_set_rec_level';

(* Const before type ignored *)
    function linphone_core_get_ringer_device(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_ringer_device';

(* Const before type ignored *)
    function linphone_core_get_playback_device(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_playback_device';

(* Const before type ignored *)
    function linphone_core_get_capture_device(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_capture_device';

(* Const before type ignored *)
    function linphone_core_set_ringer_device(lc:PLinphoneCore; devid:Pchar):longint;cdecl;external External_library name 'linphone_core_set_ringer_device';

(* Const before type ignored *)
    function linphone_core_set_playback_device(lc:PLinphoneCore; devid:Pchar):longint;cdecl;external External_library name 'linphone_core_set_playback_device';

(* Const before type ignored *)
    function linphone_core_set_capture_device(lc:PLinphoneCore; devid:Pchar):longint;cdecl;external External_library name 'linphone_core_set_capture_device';

    function linphone_core_get_sound_source(lc:PLinphoneCore):char;cdecl;external External_library name 'linphone_core_get_sound_source';

    procedure linphone_core_set_sound_source(lc:PLinphoneCore; source:char);cdecl;external External_library name 'linphone_core_set_sound_source';

(* Const before type ignored *)
    procedure linphone_core_set_ring(lc:PLinphoneCore; path:Pchar);cdecl;external External_library name 'linphone_core_set_ring';

    function linphone_core_get_ring(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_ring';

(* Const before type ignored *)
    function linphone_core_preview_ring(lc:PLinphoneCore; ring:Pchar; func:TLinphoneCoreCbFunc; userdata:pointer):longint;cdecl;external External_library name 'linphone_core_preview_ring';


    type

       PRingBackType = ^TRingBackType;
       TRingBackType = (RINGBACK_TYPE_FR,RINGBACK_TYPE_US
         );

    procedure linphone_core_set_ringback(lc:PLinphoneCore; _type:TRingBackType);cdecl;external External_library name 'linphone_core_set_ringback';

    function linphone_core_get_ringback(lc:PLinphoneCore):TRingBackType;cdecl;external External_library name 'linphone_core_get_ringback';

    procedure linphone_core_enable_echo_cancelation(lc:PLinphoneCore; val:Tbool_t);cdecl;external External_library name 'linphone_core_enable_echo_cancelation';

    function linphone_core_echo_cancelation_enabled(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_echo_cancelation_enabled';

(* Const before type ignored *)
    procedure linphone_core_set_presence_info(lc:PLinphoneCore; minutes_away:longint; contact:Pchar; os:TLinphoneOnlineStatus);cdecl;external External_library name 'linphone_core_set_presence_info';

    procedure linphone_core_add_friend(lc:PLinphoneCore; fr:PLinphoneFriend);cdecl;external External_library name 'linphone_core_add_friend';

    procedure linphone_core_remove_friend(lc:PLinphoneCore; fr:PLinphoneFriend);cdecl;external External_library name 'linphone_core_remove_friend';

    procedure linphone_core_reject_subscriber(lc:PLinphoneCore; lf:PLinphoneFriend);cdecl;external External_library name 'linphone_core_reject_subscriber';

    { a list of LinphoneFriend  }
    function linphone_core_get_friend_list(lc:PLinphoneCore):PMSList;cdecl;external External_library name 'linphone_core_get_friend_list';

    { notify all friends that have subscribed  }
    procedure linphone_core_notify_all_friends(lc:PLinphoneCore; os:TLinphoneOnlineStatus);cdecl;external External_library name 'linphone_core_notify_all_friends';

    { returns a list of LinphoneCallLog  }
    function linphone_core_get_call_logs(lc:PLinphoneCore):PMSList;cdecl;external External_library name 'linphone_core_get_call_logs';

    { video support  }
    procedure linphone_core_enable_video(lc:PLinphoneCore; val:Tbool_t);cdecl;external External_library name 'linphone_core_enable_video';

    function linphone_core_video_enabled(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_video_enabled';

    {play/record support: use files instead of soundcard }
    procedure linphone_core_use_files(lc:PLinphoneCore; yesno:Tbool_t);cdecl;external External_library name 'linphone_core_use_files';

(* Const before type ignored *)
    procedure linphone_core_set_play_file(lc:PLinphoneCore; f:Pchar);cdecl;external External_library name 'linphone_core_set_play_file';

(* Const before type ignored *)
    procedure linphone_core_set_record_file(lc:PLinphoneCore; f:Pchar);cdecl;external External_library name 'linphone_core_set_record_file';

    {
    void linphone_core_enable_video_preview(LinphoneCore *lc, bool_t val);
    bool_t linphone_core_video_preview_enabled(LinphoneCore *lc);
     }
(* Const before type ignored *)
(* Const before type ignored *)
    function linphone_core_set_video_device(lc:PLinphoneCore; method:Pchar; device:Pchar):longint;cdecl;external External_library name 'linphone_core_set_video_device';

    function linphone_core_is_in_main_thread(lc:PLinphoneCore):Tbool_t;cdecl;external External_library name 'linphone_core_is_in_main_thread';

    function linphone_core_get_user_data(lc:PLinphoneCore):pointer;cdecl;external External_library name 'linphone_core_get_user_data';

    { returns LpConfig object to read/write to the config file: usefull if you wish to extend
    the config file with your own sections  }
(* error 
struct _LpConfig *linphone_core_get_config(LinphoneCore *lc);
in declaration at line 647 *)
    procedure linphone_core_uninit(lc:PLinphoneCore);cdecl;external External_library name 'linphone_core_uninit';

    procedure linphone_core_destroy(lc:PLinphoneCore);cdecl;external External_library name 'linphone_core_destroy';

    { end of lecacy api  }
    {internal use only  }
    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_core_lock(lc : longint) : longint;    

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_core_unlock(lc : longint) : longint;    

    procedure linphone_core_start_media_streams(lc:PLinphoneCore; call:PLinphoneCall);cdecl;external External_library name 'linphone_core_start_media_streams';

    procedure linphone_core_stop_media_streams(lc:PLinphoneCore);cdecl;external External_library name 'linphone_core_stop_media_streams';

(* Const before type ignored *)
    function linphone_core_get_identity(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_identity';

(* Const before type ignored *)
    function linphone_core_get_route(lc:PLinphoneCore):Pchar;cdecl;external External_library name 'linphone_core_get_route';

(* Const before type ignored *)
    function linphone_core_interpret_url(lc:PLinphoneCore; url:Pchar; real_url:PPchar; real_parsed_url:PPosip_to_t):Tbool_t;cdecl;external External_library name 'linphone_core_interpret_url';

    function fopen(a,b:pchar):pFile; cdecl;external;
    procedure fclose(a:pFile); cdecl;external;
    
{ C++ end of extern C conditionnal removed }
//{$endif}

implementation

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_friend_url(lf : longint) : longint;
      begin
         //FIXME linphone_friend_url:=lf^.url;
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_route(obj : longint) : longint;
      begin
         //FIXME linphone_proxy_config_get_route:=obj^.reg_route;
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_identity(obj : longint) : longint;
      begin
         //FIXME linphone_proxy_config_get_identity:=obj^.reg_identity;
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_publish_enabled(obj : longint) : longint;
      begin
         //FIXME linphone_proxy_config_publish_enabled:=obj^.publish;
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_proxy_config_get_addr(obj : longint) : longint;
      begin
         //FIXME linphone_proxy_config_get_addr:=obj^.reg_proxy;
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_core_lock(lc : longint) : longint;
      begin
         //FIXME linphone_core_lock:=ms_mutex_lock(@(lc^.lock));
      end;

    { was #define dname(params) para_def_expr }
    { argument types are unknown }
    { return type might be wrong }   
    function linphone_core_unlock(lc : longint) : longint;
      begin
         //FIXME linphone_core_unlock:=ms_mutex_unlock((@(lc))^.lock);
      end;


end.
